from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('WASEnvEntry')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereWASEnvEntry");
  exportedObject.put("roleName", "WebSphereWASEnvEntry");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wasenventry.type", objid, "type","WASEnvEntry");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wasenventry.mappedname", objid, "mappedName","WASEnvEntry");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wasenventry.lookupname", objid, "lookupName","WASEnvEntry");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wasenventry.value", objid, "value","WASEnvEntry");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wasenventry.refname", objid, "refName","WASEnvEntry");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('WASEnvEntry');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('WASEnvEntry')
  if not jsonobject.has("roleProperties"):
    raise Exception("WASEnvEntry resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "type", roleProperties.optString("websphere.wasenventry.type", None));
  Util.addIfNotNone(properties, "mappedName", roleProperties.optString("websphere.wasenventry.mappedname", None));
  Util.addIfNotNone(properties, "lookupName", roleProperties.optString("websphere.wasenventry.lookupname", None));
  Util.addIfNotNone(properties, "value", roleProperties.optString("websphere.wasenventry.value", None));
  Util.addIfNotNone(properties, "refName", roleProperties.optString("websphere.wasenventry.refname", None));
  print "Creating WASEnvEntry with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("WASEnvEntry", parentid, properties);
  Util.popPathElement('WASEnvEntry');

def update(objid,jsonobject):
  Util.pushPathElement('WASEnvEntry')
  if not jsonobject.has("roleProperties"):
    raise Exception("WASEnvEntry resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wasenventry.type", None), "type","WASEnvEntry");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wasenventry.mappedname", None), "mappedName","WASEnvEntry");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wasenventry.lookupname", None), "lookupName","WASEnvEntry");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wasenventry.value", None), "value","WASEnvEntry");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wasenventry.refname", None), "refName","WASEnvEntry");
  if len(atts) != 0:
    print "Modifying WASEnvEntry with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "WASEnvEntry configuration up to date.";

  Util.popPathElement('WASEnvEntry');
